<?php
/*
Plugin Name: WP-Posts to Image
Plugin URI: http://www.birseyler.org/2010/05/wp-posts-to-image-plugin/ 
Description: Let’s you show your blog’s last posts on a forum signature or stg. uses bbcode.
Version: 0.2
Author: Utku Demir
Author URI: http://www.birseyler.org/
License: GPL2
*/
class textPNG 
{
	var $font ="fonts/dejavusans.ttf"; //default font. directory relative to script directory.
	var $msg = "no text"; // default text to display.
	var $size = 14; // default font size.
	var $rot = 0; // rotation in degrees.
	var $pad = 0; // padding.
	var $transparent = 1; // transparency set to on.
	var $red = 0; // black text...
	var $grn = 0;
	var $blu = 0;
	var $bg_red = 255; // on white background.
	var $bg_grn = 255;
	var $bg_blu = 255;
	var $fname = "./out.png";

	function draw() 
	{
		$width = 0;
		$height = 0;
		$offset_x = 0;
		$offset_y = 0;
		$bounds = array();
		$image = "";
	
		// get the font height.
		$bounds = ImageTTFBBox($this->size, $this->rot, $this->font, "W");
		if ($this->rot < 0) 
		{
			$font_height = abs($bounds[7]-$bounds[1]);		
		} 
		else if ($this->rot > 0) 
		{
		$font_height = abs($bounds[1]-$bounds[7]);
		} 
		else 
		{
			$font_height = abs($bounds[7]-$bounds[1]);
		}
		// determine bounding box.
		$bounds = ImageTTFBBox($this->size, $this->rot, $this->font, $this->msg);
		if ($this->rot < 0) 
		{
			$width = abs($bounds[4]-$bounds[0]);
			$height = abs($bounds[3]-$bounds[7]);
			$offset_y = $font_height;
			$offset_x = 0;
		} 
		else if ($this->rot > 0) 
		{
			$width = abs($bounds[2]-$bounds[6]);
			$height = abs($bounds[1]-$bounds[5]);
			$offset_y = abs($bounds[7]-$bounds[5])+$font_height;
			$offset_x = abs($bounds[0]-$bounds[6]);
		} 
		else
		{
			$width = abs($bounds[4]-$bounds[6]);
			$height = abs($bounds[7]-$bounds[1]);
			$offset_y = $font_height;;
			$offset_x = 0;
		}
		
		$image = imagecreate($width+($this->pad*2)+1,$height+($this->pad*2)+1);
		$background = ImageColorAllocate($image, $this->bg_red, $this->bg_grn, $this->bg_blu);
		$foreground = ImageColorAllocate($image, $this->red, $this->grn, $this->blu);
	
		if ($this->transparent) ImageColorTransparent($image, $background);
		ImageInterlace($image, false);
	
		// render the image
		ImageTTFText($image, $this->size, $this->rot, $offset_x+$this->pad, $offset_y+$this->pad, $foreground, $this->font, $this->msg);
	
		// output PNG object.
		imagePNG($image,$this->fname);
		#var_dump(is_writable(dirname(__FILE__)));
		#var_dump(is_writable(dirname($this->fname)));
		}
	}

add_action('admin_menu', 'my_plugin_menu');
add_action('publish_page', 'update_all');

function draw_image($post_name,$fname){
  $text=new textPNG;
  $text->msg=$post_name;
  $text->fname=dirname(__FILE__)."/".$fname;
  $text->font=dirname(__FILE__)."/fonts/dejavusans.ttf";
  $text->draw();
}

function my_plugin_menu() {

  add_options_page('Posts Banner Options', 'Posts to Image', 'manage_options', 'posts_banner', 'posts_banner_options');

}

function posts_banner_options() {

  if (!current_user_can('manage_options'))  {
    wp_die( __('You do not have sufficient permissions to access this page.') );
  }

  $process=$_GET["process"];

  $x = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));

  if($_POST['createimages']=='yes'){
  update_all();
  }
  if($_POST['shortenlinks']=='yes'){
  $link_table="";
  $link_table.="<table>";
  $link_table.="<tr><td>Images</td><td>Links</td></tr>";

  for($i=1;$i<=5;$i++){
  $link_table.="<tr><td>".shorten_url($x.$i.".png")."</td><td>".shorten_url($x.$i.".php")."</td>";
  }
  $link_table.="</table>";
  }

  echo '<div class="wrap">';

  echo '<br>';
?>
<form method="post">
	<input type=hidden name="createimages" value=yes>
	<input type=submit value="Create Images">
</form>
<form method="post">
	<input type=hidden name="shortenlinks" value=yes>
	<input type=submit value="Shorten Links" value=yes>
</form>
<?php
//  echo '<a href="wp-admin//options-general.php?page=posts_banner&process=images">Create Images</a>';
//  echo '<br>';
//  echo '<a href="wp-admin/options-general.php?page=posts_banner&process=links">Shorten Links</a>';
//  echo '<br>';
  
  echo $link_table;

  $link_table="";
  $link_table.="<table>";
  $link_table.="<tr><td>Images</td><td>Links</td></tr>";

  for($i=1;$i<=5;$i++){
  $link_table.="<tr><td>".$x.$i.".png"."</td><td>".$x.$i.".php"."</td>";
  }

  $link_table.="</table>";
  echo $link_table;
  echo '</div>';

}

function update_all(){
  create_images();
  create_redirects();
}

function create_images(){
  global $post;
  $i=1;
  foreach(get_posts("numberposts=5") as $post){
   draw_image($post->post_title,(string)$i.".png");
   $i++;
  }
}

function create_redirects(){
  global $post;
  //$x = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
  $i=1;
  foreach(get_posts("numberposts=5") as $post){
    $handle=fopen(dirname(__FILE__)."/".(string)$i.".php","w");
    fwrite($handle,"<?php\n header( 'HTTP/1.1 301 Moved Permanently' ); \n header( 'Location:".get_permalink(). "' ) ; \n?>");
  $i++;
  }
}

function shorten_url($url){
        $ch = curl_init(); 
        curl_setopt($ch, CURLOPT_URL,"http://is.gd/api.php?longurl=".$url); 
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 
        $output = curl_exec($ch); 
	curl_close($ch);      
	return $output;
}


?>
